DROP FUNCTION PRATO_RECEITA_UTIL
/

DROP TYPE PRATO_RECEITA_UTIL_TABLE
/

DROP TYPE PRATO_RECEITA_UTIL_TYPE
/

CREATE TYPE PRATO_RECEITA_UTIL_TYPE AS OBJECT
  (CDPRATO      VARCHAR2(10),
   CDFILAUXPRAT VARCHAR2(04),
   CDPRODPRODUCAO VARCHAR2(10),
   CDPRODUTO    VARCHAR2(10),
   QTPRODUTO    NUMBER,
   SGUNIDADE    VARCHAR2(05),
   VRPEFATCOC   NUMBER,
   VRPEFATCOR   NUMBER,
   HRTEMPPREP   VARCHAR2(05),
   CDAPRERECE   VARCHAR2(03),
   QTCOMPLPROD  NUMBER,
   QTBRUTAUNR   NUMBER,
   QTUNIDEST  NUMBER,
   QTLIMSEG NUMBER
  )
/

CREATE TYPE PRATO_RECEITA_UTIL_TABLE AS TABLE OF PRATO_RECEITA_UTIL_TYPE
/

create or replace FUNCTION PRATO_RECEITA_UTIL
  (P_CDFILIAL IN SERVICO.CDFILIAL%TYPE,
   P_CDSERVFILI IN SERVICO.CDSERVFILI%TYPE,
   P_CDPRATO IN PRATO.CDPRATO%TYPE,
   P_CDFILAUXPRAT IN PRATO.CDFILAUXPRAT%TYPE,
   P_CDPRODUTOINI IN PRODUTO.CDPRODUTO%TYPE DEFAULT '0',
   P_CDPRODUTOFIN IN PRODUTO.CDPRODUTO%TYPE DEFAULT 'zzzzzzzzzz'
   )
   RETURN PRATO_RECEITA_UTIL_TABLE PIPELINED IS
   OUT_RECORD PRATO_RECEITA_UTIL_TYPE := PRATO_RECEITA_UTIL_TYPE
   (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
V_CDPRATOPROD VARCHAR2(10);
V_CDFILAUXPROD VARCHAR2(04);
V_CDPRODPRODUCAO VARCHAR2(10);
BEGIN
   FOR C_RECEITA IN (
         SELECT
            R.IDTIPORECE,
            R.CDPRATO,
            R.CDFILAUXPRAT,
            R.CDPRODUTO,
            R.QTPRODUTO,
            R.SGUNIDADE,
            R.VRPEFATCOC,
            R.VRPEFATCOR,
            R.HRTEMPPREP,
            R.CDAPRERECE,
            R.QTCOMPLPROD,
            R.QTBRUTAUNR,
            PRODUTO.IDPRODPROD,
            R.QTUNIDEST,
            R.QTLIMSEG
         FROM PRODUTO,
            (SELECT
                'S' AS IDTIPORECE,
                RECESERV.CDPRATO,
                RECESERV.CDFILAUXPRAT,
                RECESERV.CDPRODUTO,
                RECESERV.QTPRODRECSER AS QTPRODUTO,
                RECESERV.SGUNIDADE,
                RECESERV.VRPEFATCOCSE AS VRPEFATCOC,
                RECESERV.VRPEFATCORSE AS VRPEFATCOR,
                RECESERV.HRTEMPPREPSE AS HRTEMPPREP,
                RECESERV.CDAPRERECE,
                0 AS QTCOMPLPROD,
                RECESERV.QTBRUTASE AS QTBRUTAUNR,
                RECESERV.QTUNIDESTSE AS QTUNIDEST,
                RECESERV.QTLIMSEGSERV AS QTLIMSEG
             FROM
                RECESERV
             WHERE
                (RECESERV.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
                (RECESERV.CDPRATO      = P_CDPRATO)         AND
                (RECESERV.CDFILIAL     = P_CDFILIAL)        AND
                (RECESERV.CDSERVFILI   = P_CDSERVFILI)
             UNION ALL
             SELECT
                'F' AS IDTIPORECE,
                RECEFILI.CDPRATO,
                RECEFILI.CDFILAUXPRAT,
                RECEFILI.CDPRODUTO,
                RECEFILI.QTPRODRECLOC AS QTPRODUTO,
                RECEFILI.SGUNIDADE,
                RECEFILI.VRPEFATCOCLO AS VRPEFATCOC,
                RECEFILI.VRPEFATCORLO AS VRPEFATCOR,
                RECEFILI.HRTEMPPREPLO AS HRTEMPPREP,
                RECEFILI.CDAPRERECE,
                RECEFILI.QTCOMPLPRODFILI AS QTCOMPLPROD,
                RECEFILI.QTBRUTALO AS QTBRUTAUNR,
                RECEFILI.QTUNIDESTLO AS QTUNIDEST,
                RECEFILI.QTLIMSEGFILI AS QTLIMSEG
             FROM
                RECEFILI
             WHERE
                (RECEFILI.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
                (RECEFILI.CDPRATO      = P_CDPRATO)         AND
                (RECEFILI.CDFILIAL     = P_CDFILIAL)        AND
                 NOT EXISTS (SELECT
                                CDPRATO
                             FROM
                                RECESERV
                             WHERE
                                (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                                (CDPRATO      = P_CDPRATO)      AND
                                (CDFILIAL     = P_CDFILIAL)     AND
                                (CDSERVFILI   = P_CDSERVFILI)
                             )
             UNION ALL
             SELECT
                'P' AS IDTIPORECE,
                RECEPADR.CDPRATO,
                RECEPADR.CDFILAUXPRAT,
                RECEPADR.CDPRODUTO,
                RECEPADR.QTPRODPRAT AS QTPRODUTO,
                RECEPADR.SGUNIDADE,
                RECEPADR.VRPEFATCOCPR AS VRPEFATCOC,
                RECEPADR.VRPEFATCORPR AS VRPEFATCOR,
                RECEPADR.HRTEMPPREPPR AS HRTEMPPREP,
                RECEPADR.CDAPRERECE,
                0 AS QTCOMPLPROD,
                RECEPADR.QTBRUTAPR AS QTBRUTAUNR,
                RECEPADR.QTUNIDESTPR AS QTUNIDEST,
                RECEPADR.QTLIMSEGPADR AS QTLIMSEG
             FROM
                RECEPADR
             WHERE
                (RECEPADR.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
                (RECEPADR.CDPRATO      = P_CDPRATO)         AND
                 NOT EXISTS (SELECT
                                CDPRATO
                             FROM
                                RECEFILI
                             WHERE
                                (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                                (CDPRATO      = P_CDPRATO)      AND
                                (CDFILIAL     = P_CDFILIAL)
                             ) AND
                 NOT EXISTS (SELECT
                                CDPRATO
                             FROM
                                RECESERV
                             WHERE
                                (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                                (CDPRATO      = P_CDPRATO)      AND
                                (CDFILIAL     = P_CDFILIAL)     AND
                                (CDSERVFILI   = P_CDSERVFILI))
         ) R
         WHERE
            (R.CDPRODUTO = PRODUTO.CDPRODUTO) AND
            (PRODUTO.CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN)
   )
   LOOP
      IF C_RECEITA.IDTIPORECE = 'S' THEN
         SELECT MIN(CDPRODPRODUCAO)
           INTO V_CDPRODPRODUCAO
         FROM PRATSERV
         WHERE CDFILIAL = P_CDFILIAL
           AND CDSERVFILI = P_CDSERVFILI
           AND CDPRATO = C_RECEITA.CDPRATO
           AND CDFILAUXPRAT = C_RECEITA.CDFILAUXPRAT;
      END IF;
      IF C_RECEITA.IDTIPORECE = 'F' THEN
         SELECT MIN(CDPRODPRODUCAO)
           INTO V_CDPRODPRODUCAO
         FROM PRATFILI
         WHERE CDFILIAL = P_CDFILIAL
           AND CDPRATO = C_RECEITA.CDPRATO
           AND CDFILAUXPRAT = C_RECEITA.CDFILAUXPRAT;
      END IF;
      IF C_RECEITA.IDTIPORECE = 'P' THEN
         SELECT MIN(CDPRODPRODUCAO)
           INTO V_CDPRODPRODUCAO
         FROM PRATPADR
         WHERE CDPRATO = C_RECEITA.CDPRATO
           AND CDFILAUXPRAT = C_RECEITA.CDFILAUXPRAT;
      END IF;
      IF (C_RECEITA.IDPRODPROD = 'S') THEN /* VERIFICAR SE  UM PRODUTO DE PRODUTO*/
         SELECT MIN(CDPRATO), MIN(CDFILAUXPRAT)
           INTO V_CDPRATOPROD, V_CDFILAUXPROD
         FROM PRATSERV
         WHERE CDFILIAL = P_CDFILIAL
           AND CDSERVFILI = P_CDSERVFILI
           AND CDPRODPRODUCAO = C_RECEITA.CDPRODUTO;
         IF V_CDPRATOPROD IS NULL THEN
            SELECT MIN(CDPRATO), MIN(CDFILAUXPRAT)
              INTO V_CDPRATOPROD, V_CDFILAUXPROD
            FROM PRATFILI
            WHERE CDFILIAL = P_CDFILIAL
              AND CDPRODPRODUCAO = C_RECEITA.CDPRODUTO;
         END IF;
         IF V_CDPRATOPROD IS NULL THEN
            SELECT MIN(CDPRATO), MIN(CDFILAUXPRAT)
              INTO V_CDPRATOPROD, V_CDFILAUXPROD
            FROM PRATPADR
            WHERE CDPRODPRODUCAO = C_RECEITA.CDPRODUTO;
         END IF;
         FOR C_REC_PROD IN
            (SELECT
                CDPRATO,
                CDFILAUXPRAT,
                CDPRODPRODUCAO,
                CDPRODUTO,
                QTPRODUTO,
                SGUNIDADE,
                VRPEFATCOC,
                VRPEFATCOR,
                HRTEMPPREP,
                CDAPRERECE,
                QTCOMPLPROD,
                QTBRUTAUNR,
                QTUNIDEST,
                QTLIMSEG
             FROM TABLE(PRATO_RECEITA_UTIL(P_CDFILIAL, P_CDSERVFILI, V_CDPRATOPROD, V_CDFILAUXPROD, P_CDPRODUTOINI, P_CDPRODUTOFIN))
         )LOOP
            OUT_RECORD.CDPRATO      := C_REC_PROD.CDPRATO;
            OUT_RECORD.CDFILAUXPRAT := C_REC_PROD.CDFILAUXPRAT;
            OUT_RECORD.CDPRODPRODUCAO := C_REC_PROD.CDPRODPRODUCAO;
            OUT_RECORD.CDPRODUTO    := C_REC_PROD.CDPRODUTO;
            OUT_RECORD.QTPRODUTO    := C_REC_PROD.QTPRODUTO;
            OUT_RECORD.SGUNIDADE    := C_REC_PROD.SGUNIDADE;
            OUT_RECORD.VRPEFATCOC   := C_REC_PROD.VRPEFATCOC;
            OUT_RECORD.VRPEFATCOR   := C_REC_PROD.VRPEFATCOR;
            OUT_RECORD.HRTEMPPREP   := C_REC_PROD.HRTEMPPREP;
            OUT_RECORD.CDAPRERECE   := C_REC_PROD.CDAPRERECE;
            OUT_RECORD.QTCOMPLPROD  := C_REC_PROD.QTCOMPLPROD;
            OUT_RECORD.QTBRUTAUNR   := C_REC_PROD.QTBRUTAUNR;
            OUT_RECORD.QTUNIDEST    := C_REC_PROD.QTUNIDEST;
            OUT_RECORD.QTLIMSEG     := C_REC_PROD.QTLIMSEG;
            PIPE ROW (OUT_RECORD);
         END LOOP;
      ELSE
         OUT_RECORD.CDPRATO      := P_CDPRATO;
         OUT_RECORD.CDFILAUXPRAT := P_CDFILAUXPRAT;
         OUT_RECORD.CDPRODPRODUCAO := V_CDPRODPRODUCAO;
         OUT_RECORD.CDPRODUTO    := C_RECEITA.CDPRODUTO;
         OUT_RECORD.QTPRODUTO    := C_RECEITA.QTPRODUTO;
         OUT_RECORD.SGUNIDADE    := C_RECEITA.SGUNIDADE;
         OUT_RECORD.VRPEFATCOC   := C_RECEITA.VRPEFATCOC;
         OUT_RECORD.VRPEFATCOR   := C_RECEITA.VRPEFATCOR;
         OUT_RECORD.HRTEMPPREP   := C_RECEITA.HRTEMPPREP;
         OUT_RECORD.CDAPRERECE   := C_RECEITA.CDAPRERECE;
         OUT_RECORD.QTCOMPLPROD  := C_RECEITA.QTCOMPLPROD;
         OUT_RECORD.QTBRUTAUNR   := C_RECEITA.QTBRUTAUNR;
         OUT_RECORD.QTUNIDEST    := C_RECEITA.QTUNIDEST;
         OUT_RECORD.QTLIMSEG     := C_RECEITA.QTLIMSEG;
         PIPE ROW (OUT_RECORD);
      END IF;
   END LOOP;
   RETURN;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PRATO_RECEITA_UTIL','6.05.000'); END;
/
